<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changeModuleAccessGlobal StructType
 * @subpackage Structs
 */
class ChangeModuleAccessGlobal extends AbstractStructBase
{
    /**
     * The filter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $filter;
    /**
     * The addAccess
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserModuleAccess
     */
    public $addAccess;
    /**
     * The removeAccess
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserModuleAccess
     */
    public $removeAccess;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for changeModuleAccessGlobal
     * @uses ChangeModuleAccessGlobal::setFilter()
     * @uses ChangeModuleAccessGlobal::setAddAccess()
     * @uses ChangeModuleAccessGlobal::setRemoveAccess()
     * @uses ChangeModuleAccessGlobal::setAuth()
     * @param string $filter
     * @param \StructType\UserModuleAccess $addAccess
     * @param \StructType\UserModuleAccess $removeAccess
     * @param \StructType\Credentials $auth
     */
    public function __construct($filter = null, \StructType\UserModuleAccess $addAccess = null, \StructType\UserModuleAccess $removeAccess = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setFilter($filter)
            ->setAddAccess($addAccess)
            ->setRemoveAccess($removeAccess)
            ->setAuth($auth);
    }
    /**
     * Get filter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFilter()
    {
        return isset($this->filter) ? $this->filter : null;
    }
    /**
     * Set filter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $filter
     * @return \StructType\ChangeModuleAccessGlobal
     */
    public function setFilter($filter = null)
    {
        // validation for constraint: string
        if (!is_null($filter) && !is_string($filter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($filter)), __LINE__);
        }
        if (is_null($filter) || (is_array($filter) && empty($filter))) {
            unset($this->filter);
        } else {
            $this->filter = $filter;
        }
        return $this;
    }
    /**
     * Get addAccess value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserModuleAccess|null
     */
    public function getAddAccess()
    {
        return isset($this->addAccess) ? $this->addAccess : null;
    }
    /**
     * Set addAccess value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserModuleAccess $addAccess
     * @return \StructType\ChangeModuleAccessGlobal
     */
    public function setAddAccess(\StructType\UserModuleAccess $addAccess = null)
    {
        if (is_null($addAccess) || (is_array($addAccess) && empty($addAccess))) {
            unset($this->addAccess);
        } else {
            $this->addAccess = $addAccess;
        }
        return $this;
    }
    /**
     * Get removeAccess value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserModuleAccess|null
     */
    public function getRemoveAccess()
    {
        return isset($this->removeAccess) ? $this->removeAccess : null;
    }
    /**
     * Set removeAccess value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserModuleAccess $removeAccess
     * @return \StructType\ChangeModuleAccessGlobal
     */
    public function setRemoveAccess(\StructType\UserModuleAccess $removeAccess = null)
    {
        if (is_null($removeAccess) || (is_array($removeAccess) && empty($removeAccess))) {
            unset($this->removeAccess);
        } else {
            $this->removeAccess = $removeAccess;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\ChangeModuleAccessGlobal
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChangeModuleAccessGlobal
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
